'------------------------------------------------------------------------------
'                              termometr04.bas
'
'                              micro: Mega168
'------------------------------------------------------------------------------

$regfile = "m168def.dat"      ' specify the used micro
$crystal = 20000000           ' used crystal frequency

$lib "mcsbyte.lbx"            ' for smaller code
$lib "ds1307clock.lib"        ' modified lib
$baud=19200                   '  

Config Clock = User           ' this will dim the bytes automatic

Declare Sub RusPage          '      1
Declare Sub PR               '      
Declare Sub PR1              '   PR,   !   
Declare Sub Video_restore    '  
Declare Sub Tstart           '       .
Declare Sub Tconvert         '      

Dim s     As   String * 16       '    
Dim s1    As   String * 10       '    video
Dim s2    As   String * 1        '    
Dim s3    As   String * 10       '
Dim ms    As   String * 115      '    15    
Dim ms1   As   String * 42       '  .   
Dim a_d   As   String * 1        '   " "
Dim a_up  As   String * 1        '   " "
Dim sdate As   String * 10       '  
Dim stime As   String * 10       '  
Dim gc    As   String * 2        '  
Dim st11  As   String * 1        '  +  -     
Dim st12  As   String * 1        '  !   -//-
Dim st21  As   String * 1        '
Dim st22  As   String * 1        '
Dim st31  As   String * 1        '
Dim st32  As   String * 1        '

Dim i       As Byte           '  
Dim ii      As Byte           '  
Dim j       As Byte           '
Dim k       As Byte           '
Dim n       As Byte           '
Dim Weekday As Byte           '  
Dim T       As Single         ' 
Dim T1      As Single         '
Dim T2      As Single         '
Dim T_old   As Single         '   
Dim T1max   As Single         '    . 
Dim T1min   As Single         '    . 
Dim T2en    As Byte           ' 1-  , 0-  
Dim T2max   As Single         '   .   2
Dim T2min   As Single         '  
Dim T3en    As Byte           ' 1-  , 0-  
Dim T3max   As Single         '   .   3
Dim T3min   As Single         '  
Dim Temp    As Single         '   
Dim row     As Byte           '    video
Dim day1    As Byte           ' 
Dim hour1   As Byte           ' 
Dim sec1    As Byte           ' 
Dim nmenu   As Byte           '   
Dim smenu   As Byte           '  , .    .
Dim level   As Byte           '     1
Dim CurStr  As Byte           ' ,   , 1  2
Dim menuitem As Byte          '   
Dim pos     As Byte           '     LCD
Dim a(8)    As Byte           ' , , , , , 
Dim er(6)   As Byte           '    ,   ..
Dim d100    As Byte           '  
Dim d10     As Byte           '  
Dim d1      As Byte           '  
Dim d01     As Byte           '  
Dim del     As Word           ' 
Dim T11     As Single         '  1
Dim T22     As Single         '  2
Dim nT1     As Byte           '   T1
Dim nT2     As Byte           '   T2
Dim signT1  As Byte           '  1
Dim signT2  As Byte           '  2
Dim warningT1 As Byte         ' 0 -   , 1 - 
Dim normalT1  As Byte         ' 0 - , 1 - , 2 -  
Dim warningT2 As Byte         '
Dim normalT3  As Byte         '
Dim warningT3 As Byte         '
Dim normalT2  As Byte         '
Dim B0      As Byte           '     
Dim B1      As Byte           '     
Dim T2ds    AS Single        '   2
Dim T3ds    As Single        '   3
Dim T2dsold As Single        '   2
Dim T3dsold As Single        '   3
Dim pm      As Byte          '    2  3
Dim color   As Byte          '  
Dim led     As Byte          ' 0 - .,  1 - .
Dim TTT(3)  As Single        '
Dim Z       As Single        '
Dim TMstartrow As Byte       '   TMstartpos   
Dim TMstartpos As Byte       '     
Dim nbuzzer As Byte          ' -    
Dim h       As Byte          '

Config PORTD.2=Output        '  , 0-TM, 1-PC

Config Sda = PortC.4          ' configure the SCL and SDA pins
Config Scl = PortC.5

Const Ds1307w = &HD0          ' addresses of DS1307 clock      WRITE
Const Ds1307r = &HD1          '                                READ

PORTD.2=1                     ' to PC
del=150                       '    , ms
a_d =CHR(&H87)                '  
a_up=CHR(&H86)                '  
gc=CHR(&HB0)                  '    2
gc=gc+"C"                     '  
ms=  " .  .   ..  T1    .  T2    .  T3        "  ' 60
                              '  90  6  15
ms1="             "
er(1)=31
er(2)=12
er(3)=99
er(4)=23
er(5)=59
er(6)=59

'Time$="14:18:40"

Cls                           '  
Cursor Off                   '  
Call RusPage                 '     1
s=""               '          
Locate 1,4                   '                    +-0,5 
Lcd s
s=" "
s=s+CHR(&HB1)                 ' -   
s=s+"0,5"
s=s+gc
Locate 2,1
Lcd s
Wait 5

$Include init1.bas           '  

PORTD.2=0                     '    
Gosub Video_restore          '
s1=Date$
day1=_day
n=40                          '  8  9
Call PR                      '  
s1=Time$
hour1=_hour
sec1=_sec
n=42                          '  10  11
Call PR                      '  

T_old = -60                   '      1
T2dsold=-60                   ' -//-  2
T3dsold=-60                   ' -//-  3
warningT1=0                   '   
warningT2=0                   '
warningT3=0                   '
led=0                         '    
st11="-"                      '
st12="N"                      '
st21="-"                      '
st22="N"                      '
st31="-"                      '
st32="N"                      '

Cls                           '  

Gosub Tstart                 '     1,2,3
Waitms 1000

pm=1                          '
nmenu=6                       '    - 6
level=0                       '   0, ..     
Enable Interrupts           '   
Enable Pcint1                '      
On Pcint1 Isr_pcint1 nosave  '      Isr_int1
Pcmsk1=&B00000100             '     PC2 - 


i=0                           '    
nbuzzer=0                     ' -    
led=0                         '
'------------------------------------------------------------------------------
M:                            '  
                              '      LCD  200 ,
 Locate 1,1                  '      ,   
 LCD Time$                   '       
 Locate 2,1                  '
 s1=Date$                     '
 LCD s1                       '
 If hour1<>_hour Then         '    
   hour1=_hour                '     
   Gosub Video_restore        ' 
   n=40                       '  8  9
   Call PR                    '  
   h=1                        '
 End If

 s1=Time$                     '     
 If sec1<>_sec Then           '   ,    
    sec1=_sec                  '   
    n=42                       '  10  11
    Call PR                   '  
 End If

 Waitms 200                   '   
 i=i+1                         '     
 If i=5 Then                  '    -  
    i=0                        '  
    For k=5 To 7              '     
      n=k-4
      1wreset PIND,k           '    D   k
      1wwrite &HCC,1,PIND,k    ' skip ROM
      1wwrite &HBE,1,PIND,k    '  stratchpad
      B0=1wread(1,PIND,k)      '   
      B1=1wread(1,PIND,k)      '
      If B1>0 Then             '  
        B0=&HFF-B0             '
        B0=B0+1                '
        Z=B0/2                 '
        TTT(n)=-Z              '
              Else
        TTT(n)=B0/2            '  
      END IF
    Next k

    T=TTT(1)
    T2ds=TTT(2)
    T3ds=TTT(3)

    If T2en=0 Then T2ds=T2dsold
    If T3en=0 Then T3ds=T3dsold

    If h=1 OR T <> T_old OR T2ds<>T2dsold OR T3ds<>T3dsold Then
                                                           '  
                                                           ' 1  2  3
       h=0                                                 '  
                               ' --------------------------------------------
                               '  1 -  
      Temp=T
      Call Tconvert
       Select Case T
         Case Is > T_old:      ' U   ( UP )
           st11="U"
         Case Is < T_old:
           st11="D"             ' D   ( DOWN )
         Case Else:
           st11="N"             ' N   
       End  SELECT
       If T<T1min Then normalT1=1
       If T>T1max Then normalT1=2
       If T>T1min AND T<T1max Then normalT1=0

       n=46
       Select Case normalT1
         Case 0:
                 If warningT1=1 Then
                    warningT1=0
                    st12="N"                    '   - 
                    RESET led.0                '   
                    Print Chr(27);"r";"1";"2"; '   1
                    k=32
                 End IF
     Case Else:
                 If warningT1=0 Then warningT1=1
                    If normalT1=1 Then
                       st12="L"                 '  
                               Else
                       st12="H"                 '  
                    End If
                 SET led.0                      '   
                 Print Chr(27);"r";"0";"2";    '   1
                 k=33

       End SELECT

       Call PR1
       Waitms 10
       PORTd.2=1                                '   PC
       Print  Date$;"_";Time$;"_T1=";s;"_";st11;st12;"__";
       Waitms 10

                               ' -------------------------------------------
                               '  2 -   
       Temp=T2ds
       Call tconvert
       Select Case T2ds
         Case Is > T2dsold:    ' U  
           st21="U"
         Case Is < T2dsold:
           st21="D"             ' D  
         Case Else:
           st21="N"             ' N   
       End  SELECT
       If T2ds<T2min Then normalT2=1
       If T2ds>T2max Then normalT2=2
       If T2ds>T2min AND T2ds<T2max Then normalT2=0

       PORTD.2=0                                 '    
       If T2en<>0 Then
         n=48
         Select Case normalT2
           Case 0:
                   If warningT2=1 Then
                      warningT2=0
                      st22="N"                    '   - 
                      RESET led.1                '   
                      Print Chr(27);"r";"1";"3"; '   2
                      k=32
                   End IF
       Case Else:
                   If warningT2=0 Then warningT2=1
                      If normalT2=1 Then
                         st22="L"                 '  
                                    Else
                         st22="H"                 '  
                      End If
                      SET led.1                   '   
                    Print Chr(27);"r";"0";"3";   '   2
                    k=33

         End SELECT

         Call PR1
         Waitms 10
         PORTD.2=1                     '    PC
         Print  "T2=";s;"_";st21;st22;"__";
       End IF
       Waitms 10

                               ' ------------------------------------------
                               '  3 -   
       Temp=T3ds
       Call Tconvert
       Select Case T3ds
         Case Is > T3dsold:    ' U  
           st31="U"
         Case Is < T3dsold:
           st31="D"             ' D  
         Case Else:
           st31="N"             ' N   
       End  SELECT
       If T3ds<T3min Then normalT3=1
       If T3ds>T3max Then normalT3=2
       If T3ds>T3min AND T3ds<T3max Then normalT3=0

       PORTD.2=0                                 '    
       If T3en<>0 Then
         n=50
         Select Case normalT3
           Case 0:
                   If warningT3=1 Then
                      warningT3=0
                      st32="N"                    '   - 
                      RESET led.2                '   
                      Print Chr(27);"r";"1";"4"; '   3
                      k=32                        '  
                   End IF
        Case Else:
                   If warningT3=0 Then warningT3=1
                      If normalT3=1 Then
                         st32="L"                 '  
                                    Else
                         st32="H"                 '  
                      End If
                      SET led.2                   '   
                      Print Chr(27);"r";"0";"4"; '   3
                      k=33                        '  . 

         End SELECT

         Call PR1
         Waitms 10
         PORTD.2=1
         Print  "T3=";s;"_";st31;st32;
       End If

       Waitms 10
       PORTD.2=1
       Print CHR(13);CHR(10);
       Waitms 10
                               ' ---------------------------------------------
       PORTD.2=0               '   -  

       T_old=T                 '  1, 2, 3
       T2dsold=T2ds            '
       T3dsold=T3ds            '

       s1="T1="                '
       s1=s1+STR(T)            '
       s1=s1+" "               '
       n=46                    '  14  15
       Call PR                '  1

       If T2en<>0 Then        '   2 
         s1="T2="              '
         s1=s1+STR(T2ds)      '
         s1=s1+" "
         n=48                  '  16  17
         Call PR              '  2
       End If

       If T3en<>0 Then         '   3 
         s1="T3="               '
         s1=s1+STR(T3ds)       '
         s1=s1+" "              '
         n=50                   '  18  19
         Call PR               '  3
       End If

    End IF


    If led=0 Then
          GOSUB LED_OFF
          nbuzzer=0
          Print Chr(27);"r";"0";"1";     '  
                Else
          If nbuzzer<7 Then              '     
             nbuzzer=nbuzzer+1
             Print Chr(27);"r";"1";"1";  '  
                   Else
             Print Chr(27);"r";"0";"1";  '  
          End If
          GOSUB LED_ON
    End If

    Locate 1,10
    s3=STR(T)
    k=Len(s3)
    If k=3 Then s="  "
    If k=4 Then s=" "
    s=s+s3
    s=s+gc
    Lcd s

    Locate 2,9
    If pm>1 Then
       s=" "
       s3=Str(T2ds)
            Else
       s=CHR(&H2A)
       s3=Str(T3ds)
    End If
    pm=-pm
    k=Len(s3)
    If k=3 Then s=s+"  "
    If k=4 Then s=s+" "
    s=s+s3
    s=s+gc
    Lcd s


   Gosub Tstart                  '     1,2,3

 End IF

Goto M


Isr_pcint1:

Pcmsk1=&B00000000             '      
PORTD.2=1                     ' to PC
Print ""
Print "  "
Print Date$                  '     
Print Time$                  '     
Print ""

menuitem=1                    '    : 

$Include level1.bas           '       
                               '    ,   
                               '  menuitem

$Include level2.bas           '    


Waitms del


Print ""

$ASM
 jmp 0                        ' RESET
$END ASM
Return


Sub RusPage                   '    
                              '  1   
'Waitus 100                   '  MT-16s2
 Portb.0=0     'A0 =0
 Portb.1=0     'E  =0
 Waitus 100
 Portb.5=0     'DB7=0   0010
 Portb.4=0     'DB6=0
 Portb.3=1     'DB5=1
 Portb.2=0     'DB4=0
 Waitus 100
 Portb.1=1
 Waitus 100
 Portb.1=0     'E=0   1 0010
 Waitus 100
 Portb.5=1
 Waitus 100
 Portb.1=1
 Waitus 100
 Portb.1=0     'E=0   2 1010
 Waitus 100

End Sub

Sub Tconvert                 '      

 s3=Str(Temp)
 k=Len(s3)
 s=""
 If Temp<0 Then
    If k=4 Then
       s3=Right(s3,3)
       s="-0"
    End If
           Else
    If k=3 Then s="00"
    If k=4 Then s="0"
 End If
 s=s+s3

End  SUB

Sub Tstart

 For k=5 To 7                    '     5,6,7  D
     1wreset PIND,k              ' 
     1wwrite &HCC,1,PIND,k       ' skip ROM
     1wwrite &H44,1,PIND,k       '   
 Next k

End SUB


Sub Video_restore
 'PORTD.2=0                     '    TM
 Print CHR(27);"E";            '  Clear Screen and Home: row=0, col=0
 For n=0 To 11                 '  "*" 22   20 
   Print Chr(27);Chr(95);"4";  '   2h 2w  
   For k=0 To 19                '   
     Print CHR(42);            ' (   )
   Next k
   Print                        '    
   Print Chr(27);Chr(95);"5";  '   2h 2w  
   For k=0 To 19                '   
     Print CHR(42);             ' (   )
   Next k
   Print
 Next n

 Print CHR(27);"H";CHR(10);CHR(10);   '  Home: row=0,col=0 , LF,LF

 For k=0 To 9                                 ' ,  
   Print CHR(42);"                 ";Chr(42) '   *  
   Print CHR(42);"                 ";Chr(42) '   *  
 Next k

 Print Chr(27);"Y";Chr(34);Chr(34); ' 2  2 
 Print "       ";
 Print Chr(27);"Y";Chr(35);Chr(34); ' 3  2 
 Print "       ";
 Print Chr(27);"Y";Chr(36);Chr(36); ' 4  4 
 Print "";
 Print Chr(27);"Y";Chr(37);Chr(36); ' 5  4 
 Print "";
 Print Chr(27);"q";"3";"/";          '    - 
 Print Chr(27);"r";"3";".";          ' PD4=0, PD5-PD7=1
 'PORTD.2=1                           '    PC

End Sub


Sub PR

   Print Chr(27);"Y";Chr(n);Chr(34);   '  n, 2 
   Print s1;
   n=n+1
   Print Chr(27);"Y";Chr(n);Chr(34);   '  n+1, 2 
   Print s1;

End SUB

Sub PR1

   Print Chr(27);"Y";Chr(n);Chr(44);   ' n  11 
   Print Chr(k);
   Print Chr(8);Chr(10);               ' Backspace, LF
   Print Chr(k);

End SUB

End                                      'end program


'called from ds1307clock.lib
Getdatetime:
  I2cstart                                         ' Generate start code
  I2cwbyte Ds1307w                                 ' send address
  I2cwbyte 0                                       ' start address in 1307

  I2cstart                                         ' Generate start code
  I2cwbyte Ds1307r                                 ' send address
  I2crbyte _sec , Ack
  I2crbyte _min , Ack                              ' MINUTES
  I2crbyte _hour , Ack                             ' Hours
  I2crbyte Weekday , Ack                           ' Day of Week
  I2crbyte _day , Ack                              ' Day of Month
  I2crbyte _month , Ack                            ' Month of Year
  I2crbyte _year , Nack                            ' Year
  I2cstop
  _sec = Makedec(_sec) : _min = Makedec(_min) : _hour = Makedec(_hour)
  _day = Makedec(_day) : _month = Makedec(_month) : _year = Makedec(_year)
Return

Setdate:
  _day = Makebcd(_day) : _month = Makebcd(_month) : _year = Makebcd(_year)
  I2cstart                                          ' Generate start code
  I2cwbyte Ds1307w                                  ' send address
  I2cwbyte 4                                        ' starting address in 1307
  I2cwbyte _day                                     ' Send Data to SECONDS
  I2cwbyte _month                                   ' MINUTES
  I2cwbyte _year                                    ' Hours
  I2cstop
Return

Settime:
  _sec = Makebcd(_sec) : _min = Makebcd(_min) : _hour = Makebcd(_hour)
  I2cstart                                          ' Generate start code
  I2cwbyte Ds1307w                                  ' send address
  I2cwbyte 0                                        ' starting address in 1307
  I2cwbyte _sec                                     ' Send Data to SECONDS
  I2cwbyte _min                                     ' MINUTES
  I2cwbyte _hour                                    ' Hours
  I2cstop
Return

LED_ON:
  I2cstart
  I2cwbyte Ds1307w
  I2cwbyte 7
  I2cwbyte &B10010000
  I2cstop
Return

LED_OFF:
  I2cstart
  I2cwbyte Ds1307w
  I2cwbyte 7
  I2cwbyte &B10000000
  I2cstop
Return